library(randomForest)
library(e1071)
library(rcdk)

input_sdf="input.sdf"
output_sdf="output.sdf"

mols2rfinput <- function(mols) {
  fps <- sapply(mols,
                function(m) {as.character(get.fingerprint(m, type = "maccs"))})
  ifps <- t(data.frame(sapply(strsplit(fps, split=NULL), as.integer)))
  colnames(ifps) <- paste("MDLPublicKeys", 1:166, "", sep=".")
  
  ifps <- data.frame(ifps, class=NA)
  ifps
}

load("metlikeness.rda")
 

mols <- load.molecules(input_sdf)
rfinput <- mols2rfinput(mols)
prob <- predict(metlikeness_model, rfinput, type="prob")

##e2 <- mapply(function(m, p) {set.property(m, "metlikeness", p[2])}, mols, prob)

e2 <- sapply(1:dim(prob)[1], function(x) set.property(mols[[x]], "metlikeness", prob[x,"HMDB"]))
print(length(mols))
write.molecules(mols, output_sdf, write.props=TRUE)
